Name:           tmt
Version:        1.40.0.dev51+g33f6bae6
Release:        1.20241212124914444388.pr3252.51.g33f6bae6%{?dist}
Summary:        Test Management Tool

License:        MIT
URL:            https://github.com/teemtee/tmt
Source0:        tmt-1.40.0.dev51+g33f6bae6.tar.gz

BuildArch:      noarch
BuildRequires:  python3-devel

Requires:       git-core rsync sshpass acl

%if 0%{?fedora} < 40
Obsoletes:      python3-tmt < %{version}-%{release}
Provides:       tmt-report-html == %{version}-%{release}
Obsoletes:      tmt-report-html < %{version}-%{release}
Provides:       tmt-report-junit == %{version}-%{release}
Obsoletes:      tmt-report-junit < %{version}-%{release}
Provides:       tmt-report-polarion == %{version}-%{release}
Obsoletes:      tmt-report-polarion < %{version}-%{release}
Provides:       tmt-report-reportportal == %{version}-%{release}
Obsoletes:      tmt-report-reportportal < %{version}-%{release}
%endif

Recommends:     bash-completion

%py_provides    python3-tmt

%global _metapackage_description %{expand:
This is a metapackage bringing in extra dependencies for tmt.
It contains no code, just makes sure the dependencies are installed.}

%description
The tmt Python module and command line tool implement the test
metadata specification (L1 and L2) and allows easy test execution.

%pyproject_extras_subpkg -n tmt export-polarion
%pyproject_extras_subpkg -n tmt report-junit
%pyproject_extras_subpkg -n tmt report-polarion
%pyproject_extras_subpkg -n tmt link-jira

%package -n     tmt+test-convert
Summary:        Dependencies required for tmt test import and export
Provides:       tmt-test-convert == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-test-convert < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       make
Requires:       python3-bugzilla
Requires:       python3-nitrate
Requires:       python3-html2text
Requires:       python3-markdown

%description -n tmt+test-convert %_metapackage_description

%package -n     tmt+provision-container
Summary:        Dependencies required for tmt container provisioner
Provides:       tmt-provision-container == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-container < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       podman
Requires:       (ansible or ansible-collection-containers-podman)

%description -n tmt+provision-container %_metapackage_description

%package -n     tmt+provision-virtual
Summary:        Dependencies required for tmt virtual machine provisioner
Provides:       tmt-provision-virtual == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-virtual < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       python3-testcloud >= 0.11.3
Requires:       libvirt-daemon-config-network
Requires:       openssh-clients
Requires:       (ansible or ansible-core)
# Recommend qemu system emulators for supported arches
Recommends:     qemu-kvm-core
%if 0%{?fedora}
Recommends:     qemu-system-aarch64-core
Recommends:     qemu-system-ppc-core
Recommends:     qemu-system-s390x-core
Recommends:     qemu-system-x86-core
%endif

%description -n tmt+provision-virtual %_metapackage_description

%package -n     tmt+provision-bootc
Summary:        Dependencies required for tmt bootc machine provisioner
Provides:       tmt-provision-bootc == %{version}-%{release}
Requires:       tmt == %{version}-%{release}
Requires:       tmt+provision-virtual == %{version}-%{release}
Requires:       podman
Recommends:     podman-machine

%description -n tmt+provision-bootc %_metapackage_description

%package -n     tmt+provision-beaker
Summary:        Dependencies required for tmt beaker provisioner
Provides:       tmt-provision-beaker == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-provision-beaker < %{version}-%{release}
%endif
Requires:       tmt == %{version}-%{release}
Requires:       python3-mrack-beaker

%description -n tmt+provision-beaker %_metapackage_description

# Replace with pyproject_extras_subpkg at some point
%package -n     tmt+all
Summary:        Extra dependencies for the Test Management Tool
Provides:       tmt-all == %{version}-%{release}
%if 0%{?fedora} < 40
Obsoletes:      tmt-all < %{version}-%{release}
%endif
Requires:       tmt+test-convert == %{version}-%{release}
Requires:       tmt+export-polarion == %{version}-%{release}
Requires:       tmt+provision-container == %{version}-%{release}
Requires:       tmt+provision-virtual == %{version}-%{release}
Requires:       tmt+provision-beaker == %{version}-%{release}
Requires:       tmt+report-junit == %{version}-%{release}
Requires:       tmt+report-polarion == %{version}-%{release}

%description -n tmt+all
All extra dependencies of the Test Management Tool. Install this
package to have all available plugins ready for testing.

%prep
%autosetup -p1 -n tmt-1.40.0.dev51+g33f6bae6

%generate_buildrequires
%pyproject_buildrequires

%build
export SETUPTOOLS_SCM_PRETEND_VERSION=%{version}
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files tmt

mkdir -p %{buildroot}%{_mandir}/man1
install -pm 644 tmt.1 %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_datadir}/bash-completion/completions
install -pm 644 completions/bash/%{name} %{buildroot}%{_datadir}/bash-completion/completions/%{name}
mkdir -p %{buildroot}/etc/%{name}/
install -pm 644 %{name}/steps/provision/mrack/mrack* %{buildroot}/etc/%{name}/

%check
%pyproject_check_import

%files -n tmt -f %{pyproject_files}
%doc README.rst examples
%{_bindir}/tmt
%{_mandir}/man1/tmt.1.gz
%{_datadir}/bash-completion/completions/%{name}

%files -n tmt+provision-container -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-virtual -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-bootc -f %{_pyproject_ghost_distinfo}
%files -n tmt+test-convert -f %{_pyproject_ghost_distinfo}
%files -n tmt+provision-beaker -f %{_pyproject_ghost_distinfo}
%config(noreplace) %{_sysconfdir}/%{name}/mrack*
%files -n tmt+all -f %{_pyproject_ghost_distinfo}

%changelog
* Thu Dec 12 2024 Packit <hello@packit.dev> - 1.40.0.dev51+g33f6bae6-1.20241212124914444388.pr3252.51.g33f6bae6
- Simplifies the arguments subprocess structure (mcasquer)
- Adds acl to be installed along with the tmt runner (mcasquer)
- Fixes issues with workdir setting (mcasquer)
- Updates ACL set after workdir_root creation (mcasquer)
- Adds missing directory in setfacl command (mcasquer)
- Changes the setfacl command and adds it to the local workdir_root creation too. (mcasquer)
- Adds sudo to setfacl command (mcasquer)
- Changes bfu_* options to use unprivileged Fedora container image and fedora user (mcasquer)
- Removes the self.become this way the condition is applied every time the user has no privileges (mcasquer)
- Removes the sudo(s) from tmt commands and instead apply it directly in the pidfile creation. Also includes the super().setup() call to the setup GuestSsh function. (mcasquer)
- Updates the environment variables in out-of-session test. This way we avoid TestingFarm to set the old values. (mcasquer)
- Fixes the tmt reboot test, updating the pidfile location in the scripts. Also formats the pid directory creation command. (mcasquer)
- Adds a check to only create the pid directory when it doesn't exist. (mcasquer)
- Makes the pidfile accessible by everyone (mcasquer)
- Refresh metadata cache after failed package installation (#3348) (Tomáš Bajer)
- Add the `--rootfs` option for `bootc` image building (#3390) (Xiaofeng Wang)
- Timestamp schema pattern should allow Z instead of zero offset (#3420) (Miloš Prchlík)
- Support passing pubkeys to authorized_keys for `mrack` (#3354) (skycastlelily)
- Speed up the `/plans/provision/container` plan (#3418) (Petr Šplíchal)
- Add support for the `when` key in step phases (#3340) (Lukáš Zachar)
- Add fallback method for generating shorter SSH master socket (#3384) (Miloš Prchlík)
- Extract `tmt try` and `tmt init` into their own `tmt.cli` modules (#3394) (Miloš Prchlík)
- Fix rendering of units when used as defaults of plugin keys (#3391) (Miloš Prchlík)
- Support `--workdir-root` in the `tmt run` command (#3386) (skycastlelily)
- Use the `rhts-report-result` alias for reporting `beakerlib` subresults (#3372) (Sabart Otto)
- Rewrite the `feature` implementation to plugins (#3276) (Izmi)
- Multiple reportportal plugin improvements and fixes (#3356) (Sabart Otto)
- Go to discover tests directory after login (#3357) (Izmi)
- Switch to the new tmt logo (#3361) (Martin Hoyer)
- Split copr project into `stable` and `latest` (#3375) (Cristian Le)
- Translate the `or` constraint properly for `mrack` (#3327) (skycastlelily)
- Mark the two known `avc` failures with `xfail` (#3411) (Petr Šplíchal)
- Document runner vs guest compatibility (#3388) (Miloš Prchlík)
- Simplify the packit configuration (#3374) (Cristian Le)
- Update contribution doc with `tldr` pages info (#3377) (Martin Hoyer)
- Encourage contributors to keep pull requests up-to-date (#3408) (Petr Šplíchal)
- Do not use `mypy` cache for `ruamel.yaml` (#3404) (Martin Hoyer)
- Store multiple invocations of dmesg check for the same test in one file (#3393) (Miloš Prchlík)
- Add `link` config validation using `pydantic` (#3339) (Filip Vágner)
- Pre-commit hooks version bump (#3402) (Martin Hoyer)
- Fix log paths for subresults loaded from tmt-report-results.yaml (#3370) (Sabart Otto)
- Implement the `--keep` option for `tmt clean` (#3183) (#3183) (skycastlelily)
- Update the `actions/upload-artifact` version (#3389) (Petr Šplíchal)
- Do not save the logs into memory using an auxiliary variable (#3382) (Sabart Otto)
- Enable the `huge_tree` option for the `lxml` parser (#3365) (Sabart Otto)
- Implement the `--keep` option for `tmt clean guests` (#3182) (skycastlelily)
- Fix reuse of already provisioned machine (#3381) (Lukáš Zachar)
- Support `--workdir-root` in the `tmt clean` command (#2850) (skycastlelily)
- Uninstall bootc in Fedora CoreOS testing image (#3380) (Miloš Prchlík)
- Document overview of supported `restraint` scripts (#3379) (Petr Šplíchal)
- Handle invalid option in the `tmt-reboot` script (#3358) (Petr Šplíchal)
